! function(u, c) {
    "use strict";

    function n(t) {
        this.gallery = [], this.currentImageIndex = void 0, this.init(), this.options = Object.assign({}, this.constructor.defaults), this.option(t)
    }
    "undefined" != typeof module && void 0 !== module.exports ? module.exports = n : "function" == typeof define && define.amd ? define([], function() {
        return n
    }) : u.Lumenbox = n, n.easing = {
        linear: function(t) {
            return t
        },
        quadratic: function(t) {
            return Math.pow(t, 2)
        },
        swing: function(t) {
            return .5 - Math.cos(t * Math.PI) / 2
        },
        circ: function(t) {
            return 1 - Math.sin(Math.acos(t))
        },
        back: function(t, e) {
            return Math.pow(t, 2) * ((e + 1) * t - e)
        },
        bounce: function(t) {
            for (var e = 0, n = 1;; e += n, n /= 2)
                if ((7 - 4 * e) / 11 <= t) return -Math.pow((11 - 6 * e - 11 * t) / 4, 2) + Math.pow(n, 2)
        },
        elastic: function(t, e) {
            return Math.pow(2, 10 * (t - 1)) * Math.cos(20 * Math.PI * e / 3 * t)
        }
    }, n.prototype.effects = {
        animate: function(n) {
            var i = new Date;
            n.before && n.before();
            var o = setInterval(function() {
                var t = (new Date - i) / n.duration;
                1 < t && (t = 1), n.progress = t;
                var e = n.delta(t);
                n.step(e), 1 === t && (clearInterval(o), n.complete && n.complete())
            }, n.delay || 10)
        },
        fadeOut: function(e, t) {
            this.animate({
                before: t.before,
                duration: t.duration,
                delta: function(t) {
                    return t = this.progress, n.easing.swing(t)
                },
                complete: t.complete,
                step: function(t) {
                    e.style.opacity = 1 - t
                }
            })
        },
        fadeIn: function(e, t) {
            this.animate({
                before: t.before,
                duration: t.duration,
                delta: function(t) {
                    return t = this.progress, n.easing.swing(t)
                },
                complete: t.complete,
                step: function(t) {
                    e.style.opacity = 0 + t
                }
            })
        }
    }, n.defaults = {
        countLabel: "%current of %total",
        fitInViewport: !0,
        showCounter: !1,
        infiniteNavigation: !1,
        enableKeyboardNavigation: !1,
        transitionDuration: 500,
        backDropClose: !0
    }, n.prototype.option = function(t) {
        this.options = Object.assign(this.options, t)
    }, n.prototype.imageCountLabel = function(t, e) {
        return this.options.countLabel.replace(/%current/g, t).replace(/%total/g, e)
    }, n.prototype.init = function() {
        var t = this;
        c.addEventListener("DOMContentLoaded", function() {
            t.enable(), t.build()
        }, !1)
    }, n.prototype.build = function() {
        if (!c.getElementById("lumenbox")) {
            var e = this;
            c.body.insertAdjacentHTML("beforeEnd", '<div id="lumenbox-overlay" class="lumenbox-overlay"></div><div id="lumenbox" class="lumenbox">\t<div class="lumenbox-container">    <img src="" alt="" id="lumenbox-img"/>    <div class="lumenbox-info">      <span id="lumenbox-caption"></span>      <span id="lumenbox-counter"></span>    </div>    <div id="lumenbox-navigation">      <span class="lumenbox-control lumenbox-prev" id="lumenbox-prev"></span>      <span class="lumenbox-control lumenbox-next" id="lumenbox-next"></span>    </div>  </div>\t<div id="lumenbox-close">\t\t<span>×</span>\t</div></div>'), this.backDrop = c.getElementById("lumenbox-overlay"), this.lumenbox = c.getElementById("lumenbox"), this.closeButton = c.getElementById("lumenbox-close"), this.prevButton = c.getElementById("lumenbox-prev"), this.nextButton = c.getElementById("lumenbox-next"), this.caption = c.getElementById("lumenbox-caption"), this.counter = c.getElementById("lumenbox-counter"), this.options.backDropClose && this.backDrop.addEventListener("click", function() {
                return e.finish(), !1
            }), this.closeButton.addEventListener("click", function() {
                return e.finish(), !1
            }), this.prevButton.addEventListener("click", function() {
                0 === e.currentImageIndex ? e.changeImage(e.gallery.length - 1) : e.changeImage(e.currentImageIndex - 1)
            }), this.nextButton.addEventListener("click", function() {
                e.currentImageIndex === e.gallery.length - 1 ? e.changeImage(0) : e.changeImage(e.currentImageIndex + 1)
            }), u.addEventListener("keydown", function(t) {
                if ("Escape" === t.key || "Esc" === t.key || 27 === t.keyCode) return e.finish(), !1;
                if (e.options.enableKeyboardNavigation) {
                    if ("ArrowRight" === t.key || 39 === t.keyCode) return e.options.infiniteNavigation ? e.currentImageIndex === e.gallery.length - 1 ? e.changeImage(0) : e.changeImage(e.currentImageIndex + 1) : e.currentImageIndex !== e.gallery.length - 1 && e.changeImage(e.currentImageIndex + 1), !1;
                    if ("ArrowLeft" === t.key || 37 === t.keyCode) return e.options.infiniteNavigation ? e.currentImageIndex ? e.changeImage(e.currentImageIndex - 1) : e.changeImage(e.gallery.length - 1) : e.currentImageIndex && e.changeImage(e.currentImageIndex - 1), !1
                }
            }), this.options.fitInViewport && u.addEventListener("resize", e.resize)
        }
    }, n.prototype.enable = function() {
        var e = this;
        c.querySelectorAll("a[rel^=lumenbox], area[rel^=lumenbox], a[data-lumenbox], area[data-lumenbox]").forEach(function(t) {
            t.addEventListener("click", function() {
                return event.preventDefault(), e.start(event.currentTarget), !1
            })
        })
    }, n.prototype.start = function(t) {
        var e = this;
        this.gallery = [];
        var n = 0;
        var i, o, a = t.getAttribute("data-lumenbox");
        if (a) {
            i = c.querySelectorAll('[data-lumenbox="' + a + '"]');
            for (var r = 0; r < i.length; r = ++r) o = {
                src: i[r].getAttribute("href"),
                title: i[r].getAttribute("title") || i[r].dataset.title
            }, e.gallery.push({
                src: o.src,
                title: o.title
            }), i[r] === t && (n = r)
        }
        this.effects.fadeIn(this.backDrop, {
            before: function() {
                e.backDrop.style.display = "block"
            },
            duration: this.options.transitionDuration
        }), this.effects.fadeIn(this.lumenbox, {
            before: function() {
                e.lumenbox.style.display = "block"
            },
            duration: this.options.transitionDuration
        }), this.changeImage(n)
    }, n.prototype.resize = function() {
        var t, e, n, i, o = c.getElementById("lumenbox-img");
        i = Math.max(c.documentElement.clientWidth, u.innerWidth || 0) - 130 - 40, n = Math.max(c.documentElement.clientHeight, u.innerHeight || 0) - 55 - 40, o.width / i > o.height / n ? (e = i, t = parseInt(o.height / (o.width / e), 10)) : (t = n, e = parseInt(o.width / (o.height / t), 10)), o.width = e, o.height = t
    }, n.prototype.changeImage = function(o) {
        var a = this,
            r = this.gallery[o].src,
            s = (r.split(".").slice(-1)[0], c.getElementById("lumenbox-img")),
            l = new Image;
        l.onload = function() {
            var t, e, n, i;
            s.setAttribute("alt", a.gallery[o].alt), s.setAttribute("src", r), a.options.fitInViewport && (i = Math.max(c.documentElement.clientWidth, u.innerWidth || 0) - 130 - 40, n = Math.max(c.documentElement.clientHeight, u.innerHeight || 0) - 55 - 40, (l.width > i || l.height > n) && (l.width / i > l.height / n ? (e = i, t = parseInt(l.height / (l.width / e), 10)) : (t = n, e = parseInt(l.width / (l.height / t), 10)), s.width = e, s.height = t))
        }, l.src = this.gallery[o].src, this.currentImageIndex = o, this.updateInfo(), this.updateNavigation()
    }, n.prototype.updateInfo = function() {
        this.gallery[this.currentImageIndex].title && (this.caption.innerHTML = this.gallery[this.currentImageIndex].title), 1 < this.gallery.length && this.options.showCounter ? (this.counter.innerText = this.imageCountLabel(this.currentImageIndex + 1, this.gallery.length), this.counter.style.display = "block") : this.counter.style.display = "none"
    }, n.prototype.updateNavigation = function() {
        this.prevButton.style.display = "none", this.nextButton.style.display = "none", 1 < this.gallery.length && (this.options.infiniteNavigation ? (this.prevButton.style.display = "block", this.nextButton.style.display = "block") : (0 < this.currentImageIndex && (this.prevButton.style.display = "block"), this.currentImageIndex < this.gallery.length - 1 && (this.nextButton.style.display = "block")))
    }, n.prototype.finish = function() {
        var t = this;
        this.effects.fadeOut(this.backDrop, {
            duration: this.options.transitionDuration,
            complete: function() {
                t.backDrop.style.display = "none"
            }
        }), this.effects.fadeOut(this.lumenbox, {
            duration: this.options.transitionDuration,
            complete: function() {
                t.lumenbox.style.display = "none"
            }
        })
    }
}(window, document);

